Error when displaying a news with comments in reverse order
Status: Closed Start date:

Priority: High Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: News Estimated time: 0.00 hour
Target version:

Resolution: Fixed Affected version:

Description

Extra bang after

@comments.reverse

in news_controller.rb causes 500 error if no comments are present while

User.current.wants_comments_in_reverse_order? == true

Associated revisions

Revision 13595 - 2014-11-14 21:53 - Jean-Philippe Lang

Fixed 500 error when displaying a news with comments in reverse order (#18332).

History

#1 - 2014-11-12 23:29 - Denis Savitskiy

Well, the solution is as simple as this: remove 'l after 'reverse' (link: source:/trunk/app/controllers/news_controller.rb#L 62 )

#2 - 2014-11-13 00:35 - Toshi MARUYAMA

- Target version set to 2.6.1

#3 - 2014-11-14 21:23 - Jean-Philippe Lang
- Status changed from New to Needs feedback

- Target version deleted (2.6.1)

Please read SubmittingBugs.

@comments can not be nil in NewsController#show. Also, #reverse! is required here, not #reverse:
http://www.ruby-doc.org/core-2.1.5/Array.html#method-i-reverse

#4 - 2014-11-14 21:29 - Denis Savitskiy

Jean-Philippe Lang wrote:
Please read SubmittingBugs.

@comments can not be nil in NewsController#show. Also, #reverse! is required here, not #reverse:
http://www.ruby-doc.org/core-2.1.5/Array.html#method-i-reverse

What is the purpose of this bang? You are not storing the order. You simply change the order in array before showing it to user.

#5 - 2014-11-14 21:56 - Jean-Philippe Lang

- Subject changed from Extra bang after @comments.reverse in news_controller causes 500 error to Error when displaying a news with comments in
reverse order

- Status changed from Needs feedback to Resolved

- Assignee set to Jean-Philippe Lang

2025-06-18 1/2



https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/app/controllers/news_controller.rb#L62
https://www.redmine.org/projects/redmine/wiki/SubmittingBugs
http://www.ruby-doc.org/core-2.1.5/Array.html#method-i-reverse
https://www.redmine.org/projects/redmine/wiki/SubmittingBugs
http://www.ruby-doc.org/core-2.1.5/Array.html#method-i-reverse

- Target version set to 2.6.1
- Resolution set to Fixed
Fixed in r13595.

The problem was not with the bang nor the fact that there are no comments. It would have been easier to get it with your stack trace but thanks
anyway for reporting this.

What is the purpose of this bang? You are not storing the order. You simply change the order in array before showing it to user.

#reverse returns a reversed array but leaves the array unchanged, so we'd have to use @comments = @comments.reverse instead of
@comments.reverse!

#6 - 2014-11-14 22:05 - Jean-Philippe Lang
- Status changed from Resolved to Closed

- Target version deleted (2.6.1)

- Affected version deleted (2.6.0)

2.6 stable is not affected, trunk only.

#7 - 2014-11-14 22:50 - Denis Savitskiy

Jean-Philippe Lang wrote:
Fixed in r13595.
Thanks!
#reverse returns a reversed array but leaves the array unchanged, so we'd have to use @comments = @comments.reverse instead of

@comments.reverse!

Sure! | didn't mention that.

2025-06-18 22


https://www.redmine.org/projects/redmine/repository/svn/revisions/13595
https://www.redmine.org/projects/redmine/repository/svn/revisions/13595
http://www.tcpdf.org

